; GWASL3_ASM on H259_gwasl18_
; and win1_ass
; 14th November 2002
;
; Version 1.8
;
; 1. Correct MOVEP for mem -> reg
;
; Version 1.7
;
; 1. Store SIZE for PR17 - MOVEA
;
; Version 1.5
;
; 1. Pr18 - Alter branch from BEQ to BLT to PR18_D
;
; Version 1.2
;
; 1. PR2 - "bra.s *" now correctly assembled
; 2. PR24 - allow "future" labels & EQU lists in DC
;
; An ASSEMBLER program
;    PART 3
;
; The programs for each instruction
;  PR_EQ & PR1 to PR31
;
PR_EQ	LEA	MARK,A3
	TST.W	(A3)
	BEQ	PR_E4 ---->
	MOVEA.L	BLLAB,A2
	MOVE.W	2(A3),D1
	EXT.L	D1
	LSL.L	#5,D1
	ADDA.L	D1,A2
	CLR.W	(A3)	clear MARK
	CMPI.B	#32,D0	space after EQU?
	BEQ.S	PR_EQS
	CMPI.B	#9,D0	tab?
	BNE	PR_E19 ---->
PR_EQS	CMPI.B	#32,(A1)+
	BEQ.S	PR_EQS
	CMPI.B	#9,-1(A1) tab? . .
	BEQ.S	PR_EQS	. . yes
	MOVE.B	-1(A1),D0 1st character of num
	BSR	GNUM1
	TST.B	D1
	BMI.S	PR_E1 ---->
	BEQ.S	PR_EQL
	CMPI.B	#4,D1
	BEQ.S	PR_LAB
	MOVE.L	D2,VAL(A2)
	ADDQ.W	#4,D1
	ANDI.W	#3,TYPE(A2)
	OR.W	D1,TYPE(A2)
	BRA	INST_ED1
PR_EQL	MOVEA.L	EQB,A6
	MOVEA.L	(A6),A0
	MOVEA.L	EQT,A3
	LEA	-10(A3),A3
	CMPA.L	A3,A0
	BGE.S	PR_E10 ---->
	MOVE.L	A0,VAL(A2)
	CLR.L	(A0)+	constant in EQ list ->0
	CLR.W	(A0)+	S(PC) = 0
	TST.L	D2
	BMI.S	PR_EQLM
	MOVEQ	#1,D1
	BRA.S	PR_EQLP
PR_EQLM	MOVEQ	#-1,D1
PR_EQLP	MOVE.W	D1,(A0)+	+ or -
	MOVE.W	D2,(A0)+	EQlist pointer
	MOVE.W	#8,TYPE(A2)	set LABEL -> EQlist
	MOVE.L	A0,(A6)	update pointer
	BRA	INST_ED1
PR_LAB	BCLR	#31,D2
	MOVE.L	D2,VAL(A2)
	ANDI.W	#3,TYPE(A2)
	ORI.W	#8,TYPE(A2)
	BRA	INST_ED1
;
PR_E1	MOVEQ	#1,D1
PR_EXX	BSR	DO_ERR
	BRA	INST_ED2
PR_E2	MOVEQ	#2,D1
	BRA.S	PR_EXX
PR_E3	MOVEQ	#3,D1
	BRA.S	PR_EXX
PR_E4	MOVEQ	#4,D1
	BRA.S	PR_EXX
PR_E5	MOVEQ	#5,D1
	BRA.S	PR_EXX
PR_E6	MOVEQ	#6,D1
	BRA.S	PR_EXX
PR_E7	MOVEQ	#7,D1
	BRA.S	PR_EXX
PR_E8	MOVEQ	#8,D1
	BRA.S	PR_EXX
PR_E9	MOVEQ	#9,D1
	BRA.S	PR_EXX
PR_E10	MOVEQ	#10,D1
	BRA.S	PR_EXX
PR_E11	MOVEQ	#11,D1
	BRA.S	PR_EXX
PR_E12	MOVEQ	#12,D1
	BRA.S	PR_EXX
PR_E13	MOVEQ	#13,D1
	BRA.S	PR_EXX
PR_E14	MOVEQ	#14,D1
	BRA.S	PR_EXX
PR_E15	MOVEQ	#15,D1
	BRA.S	PR_EXX
PR_E16	MOVEQ	#16,D1
	BRA.S	PR_EXX
PR_E17	MOVEQ	#17,D1
	BRA.S	PR_EXX
PR_E18	MOVEQ	#18,D1
	BRA.S	PR_EXX
PR_E19	MOVEQ	#19,D1
	BRA.S	PR_EXX
PR_E20	MOVEQ	#20,D1
	BRA.S	PR_EXX
PR_E21	MOVEQ	#21,D1
	BRA.S	PR_EXX
PR_E22	MOVEQ	#22,D1
	BRA.S	PR_EXX
PR_E23	MOVEQ	#23,D1
	BRA.S	PR_EXX
PR_E24	MOVEQ	#24,D1
	BRA.S	PR_EXX
PR_E25	MOVEQ	#25,D1
	BRA.S	PR_EXX
PR_E26	MOVEQ	#26,D1
	BRA.S	PR_EXX
PR_E27	MOVEQ	#27,D1
	BRA.S	PR_EXX
PR_E28	MOVEQ	#28,D1
	BRA.S	PR_EXX
PR_E29	MOVEQ	#29,D1
	BRA.S	PR_EXX
PR_E30	MOVEQ	#30,D1
	BRA.S	PR_EXX
;
; NOP, RTS, RESET, RET, RTR
;
PR1	BRA	INST_END
;
; Bcc, BSR
;
PR2
	MOVE.W	D1,D7
	SUBQ.W	#1,D7	0=short 1=long
PR2_E	SUBQ.L	#2,A5	So that * refers to the start - altered .
	BSR	GNUM			      . . 1 FEB 00
	ADDQ.L	#2,A5
	TST.B	D1
	BMI	INST_END ---->
	BEQ.S	P2_LAB
	CMPI.B	#2,D1
	BMI	PR_E5 ---->
	BGT.S	P2_DUM	do dummy label
	MOVE.L	D2,D3
	SUB.L	A5,D3	LAB - *
	TST.L	D7	SHORT?
	BEQ.S	P2_SE	yes
	BSR	PUT_W
	MOVE.W	D3,D5
P2_SE1	ADDQ.L	#2,A5
	BRA.S	P2_END1
P2_SE	CMPI.L	#128,D3
	BGE	PR_E6 ---->
	CMPI.L	#-128,D3
	BLT	PR_E6 ---->
	MOVE.B	D3,D5
	BEQ.S	PR_E25 ---->   zero jump not allowed
P2_END1	BRA	INST_END
P2_LAB	MOVE.W	D2,D3
	EXT.L	D3
	MOVEA.L	BLLAB,A0
	LSL.L	#5,D3
	ADDA.L	D3,A0
	BSET	#1,TYPE+1(A0)	mark PC
P2_INS	MOVEQ	#0,D6
	MOVEA.L	BINS,A3
	MOVEA.L	(A3),A0
	MOVE.L	A5,D1
	TST.B	D7
	BNE.S	P2_INSL
	SUBQ.L	#2,D1
	MOVEQ	#2,D6
P2_INSL	MOVE.L	D1,(A0)+	PC
	MOVE.W	D2,(A0)+	LAB No
	MOVE.B	D6,(A0)+	W
	MOVE.B	#10,D6
	ADD.B	D7,D6	10 or 11
	MOVE.B	D6,(A0)+	type
	MOVE.L	A0,(A3)	reset pointer
	TST.B	D7
	BEQ	INST_END	short
	BSR	PUT_W
	MOVEQ	#0,D5	clear word
	BRA.S	P2_SE1
P2_DUM	MOVEQ	#-1,D1
	MOVEA.L	BLLAB,A0
	MOVEA.L	TLLAB,A2
P2_DUM1	ADDQ.L	#1,D1
	TST.W	(A0)
	BEQ.S	P2_DUMF
	LEA	32(A0),A0
	CMPA.L	A2,A0
	BGE	PR_E8 ---->
	BRA.S	P2_DUM1
P2_DUMF	MOVE.W	#-1,(A0)
	MOVE.W	#10,TYPE(A0)	type PC|EQlist
	MOVE.L	D2,VAL(A0)
	MOVE.L	D1,D2	set LAB No to D2 for INS
	BRA.S	P2_INS
;
; DBcc
;
PR3
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	MOVEQ	#1,D7	mark LONG
	BRA	PR2_E
;
; ASL, ASR, LSL, LSR, ROL, ROR, ROXL, ROXR
;
PR4	TST.B	D1
	BPL.S	PR4_F
	MOVEQ	#1,D1
PR4_F	LSL.W	#6,D1
	OR.W	D1,D5
	LEA	SIZE,A0
	MOVE.B	#3,(A0)
	SUBQ.L	#2,A5
	BSR	EA
	ADDQ.L	#2,A5
	MOVE.W	D2,D3
	ANDI.W	#$3F,D3
	CMPI.W	#$3C,D3	7(4)?
	BEQ.S	PR4_74	yes
	CMPI.W	#8,D3	D?
	BLT.S	PR4_D	yes
	MOVE.W	D5,D4
	ANDI.W	#$18,D4
	LSL.W	#6,D4
	OR.W	D4,D5
PR4_ZR	ANDI.W	#$FFC0,D5 clear <ea>
	OR.W	D3,D5
	ORI.W	#192,D5
	BRA	INST_END
PR4_D	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	ORI.W	#32,D5
	ANDI.W	#$FFF8,D5 clear reg
PR4_74	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	BRA	INST_END
;
; MOVE
;
PR5	LEA	SIZE,A0
	MOVE.B	D1,(A0)	set SIZE for EA
	MOVE.B	D1,D6	& keep it in D6
	BSR	MOTR
	BNE.S	PR5_NOR	not mode 7
	ANDI.W	#7,D3	reg
	CMPI.W	#5,D3
	BGE.S	PR5_SCU	SR, CCR or USP
PR5_NOR	SWAP	D7
	BSR	MOTR
	BNE.S	PR5_NORX
	ANDI.W	#7,D3
	CMPI.W	#5,D3
	BGE.S	PR5_SCU1
PR5_NORX	MOVE.W	#$1000,D1
	CMPI.B	#1,D6
	BMI.S	PR5_NORB
	BGT.S	PR5_NORL
	ADD.W	D1,D1
PR5_NORL	ADDI.W	#$1000,D1
PR5_NORB	OR.W	D1,D5
	LSL.W	#3,D2	mode
	OR.W	D2,D5
	ANDI.W	#7,D3	reg
	ADD.W	D3,D3
	LSL.W	#8,D3
	OR.W	D3,D5
	BRA	INST_END
PR5_SCU	BEQ.S	PR5_SR
	CMPI.W	#6,D3
	BEQ.S	PR5_CCR
	MOVE.W	#$4E68,D5
	MOVE.W	MSEVA,D7
	BSR	EA
	ANDI.B	#7,D2
	OR.B	D2,D5
	BRA	INST_END
PR5_SR	MOVE.W	#$40C0,D5
PR5_SR1	MOVE.W	MSEV,D7
	BSR	EA
	BRA	INST_END
PR5_CCR	MOVE.W	#$42C0,D5
	BRA.S	PR5_SR1
;
MSEV	DC.W	$FE02	all but A & enter it
MSEVA	DC.W	$7FFD	only A (not entered)
;
PR5_SCU1	BEQ.S	PR5_SC1
	CMPI.B	#6,D3
	BEQ.S	PR5_CCR1
	MOVE.W	D5,D4
	ANDI.W	#$38,D4
	CMPI.W	#8,D4	    A?
	BNE	PR_E14 ---->  no
	ANDI.W	#7,D5
	ORI.W	#$4E60,D5
	BRA	INST_END
PR5_SC1	ANDI.W	#$3F,D5
	ORI.W	#$46C0,D5
	BRA	INST_END
PR5_CCR1	ANDI.W	#$3F,D5
	ORI.W	#$44C0,D5
	BRA	INST_END
;
MOTR	BSR	EA
	MOVE.W	D2,D3
	ANDI.W	#$38,D2	mode
	CMPI.B	#$8,D2	A?
	BNE.S	MOTR1	no
	TST.B	D6
	BNE.S	MOTR1
	ADDQ.L	#4,A7
	BRA	PR_E16 ---->
MOTR1	CMPI.B	#$38,D2	mode 7?
	RTS
;
; ADD, SUB, OR, AND, CMP
;
PR6	LEA	SIZE,A0
	MOVE.B	D1,(A0)
	MOVE.B	D1,D6
	LSL.W	#6,D1
	OR.W	D1,D5
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	ANDI.W	#$38,D2
	BNE.S	PR6_EA
	SWAP	D7
	BSR	EA
	MOVE.W	D2,D3
	ANDI.W	#$38,D3	D?
	BEQ.S	PR6_EA1	yes
	MOVE.W	D5,D3
	ANDI.W	#$FFC0,D5 delete <ea>
	ANDI.W	#7,D3	keep reg
	ADD.W	D3,D3
	LSL.W	#8,D3
	OR.W	D3,D5
	ANDI.W	#$3F,D2	<ea>
	ADDI.W	#256,D2
	BRA.S	PR6_EA2
PR6_EA	CMPI.W	#8,D2
	BNE.S	PR6_EA3	not A
	TST.B	D6
	BEQ	PR_E16 ---->
PR6_EA3	MOVE.W	#$7FFE,D7
	BSR	EA
PR6_EA1	ANDI.W	#7,D2
	ADD.W	D2,D2
	LSL.W	#8,D2
PR6_EA2	OR.W	D2,D5
	BRA	INST_END
;
; MOVEM
;
PR7	ADDQ.L	#2,A5	PC + 2
	MOVEQ	#0,D6	prepare for reg list
	SUBQ.W	#1,D1
	BMI	PR_E16 ---->
	LSL.W	#6,D1
	OR.W	D1,D5
	BSR	EA
PR7_RET1	CMPI.B	#16,D2	A,D?
	BLT.S	PR7_AD	yes
	BSET	#10,D5	mark mem->reg
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
PR7_GA	MOVE.B	(A1)+,D0
	CMPI.B	#57,D0
	BLT	PR_E13 ---->
	BSR	PR7_SRL	get reg ->D1
	MOVE.B	D1,D2
PR7_AD1	BSET	D1,D6
PR7_AD2	MOVE.B	(A1)+,D0
	CMPI.B	#"/",D0
	BEQ.S	PR7_GA
	CMPI.B	#"-",D0
	BEQ.S	PR7_GR
	CMPI.B	#",",D0
	BEQ.S	PR7_FL1
	CMPI.B	#32,D0
	BEQ.S	PR7_FL2
	CMPI.B	#9,D0
	BEQ	PR7_FL2
	CMPI.B	#10,D0
	BEQ.S	PR7_FL2
	BRA	PR_E22 ---->
PR7_AD	MOVE.B	D2,D1
	ANDI.W	#$FFC0,D5 clear mode|reg (part of reg list)
	SUBQ.L	#1,A1	reset A1
	BRA.S	PR7_AD1
PR7_GR	TST.B	D2
	BMI	PR_E22 ---->
	MOVE.B	(A1)+,D0
	CMPI.B	#57,D0
	BGT.S	PR7_GRL
	MOVE.B	D2,D1
	ANDI.B	#8,D1	D or A -> D1
	BSR.S	PR7_NUL
	BRA.S	PR7_GRA
PR7_GRL	BSR.S	PR7_SRL
PR7_GRA	MOVE.B	D2,D0
	EOR.B	D1,D0
	BTST	#3,D0
	BNE	PR_E22 ---->
	CMP.B	D1,D2
	BGE	PR_E22 ---->
PR7_GRB	ADDQ.B	#1,D2
	BSET	D2,D6
	CMP.B	D1,D2
	BLT.S	PR7_GRB
	MOVEQ	#-1,D2
	BRA.S	PR7_AD2
PR7_FL1	BTST	#10,D5
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
PR7_FL1A	BSR	PUT_W
	AND.W	#$38,D5
	CMPI.W	#$20,D5	mode 4?
	BEQ.S	PR7_REV	yes
PR7_FL1B	MOVE.W	D6,D5
	BRA	INST_END
PR7_FL2	BTST	#10,D5
	BEQ	PR_E19 ---->
	BRA.S	PR7_FL1A
;
PR7_SRL	SUBI.B	#68,D0
	BLE.S	PR7_SR1
	SUBI.B	#32,D0
PR7_SR1	BEQ.S	PR7_SR2
	ADDI.B	#11,D0
	CMPI.B	#8,D0	    A?
	BNE.S	PR7_SRE ----> no
PR7_SR2	MOVE.B	D0,D1
	MOVE.B	(A1)+,D0
PR7_NUL	SUBI.B	#48,D0
	BLT.S	PR7_SRE ---->
	CMPI.B	#7,D0
	BGT.S	PR7_SRE
	ADD.B	D0,D1
	RTS
;
PR7_REV	MOVEQ	#15,D0
	MOVEQ	#0,D5
PR7_REV1	LSR.W	#1,D6
	BCC.S	PR7_REV2
	BSET	D0,D5
PR7_REV2	DBF	D0,PR7_REV1
	BRA	INST_END
;
PR7_SRE	ADDQ.L	#4,A7
	BRA	PR_E22 ---->
;
; ADDI, ANDI, CMPI, EORI, ORI, SUBI
;
PR8	LEA	SIZE,A0
	MOVE.B	D1,D4	keep size in D4
	TST.B	D1
	BPL.S	PR8_S
	MOVEQ	#1,D1	set WORD
PR8_S	MOVE.B	D1,(A0)
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	CMPI.B	#$3D,D2	CCR, SR?
	BLT.S	PR8_D	no
	BEQ.S	PR8_A1	SR
	LEA	OBUF+4,A0
	MOVE.W	(A0),D2
	BSR	CMP_B
	BMI	PR_E2
PR8_A1	BCLR	#0,D5
	BEQ.S	PR8_A
	BSET	#6,D5
PR8_A	BCLR	#1,D5
	BRA	INST_END
PR8_D	TST.B	D4	size OK?
	BMI	PR_E16 ----> no
	LSL.W	#6,D4
	OR.W	D4,D5	insert size
	BRA	INST_END
;
; ABCD, ADDX, CMPM, SBCD, SUBX
;
PR9	TST.B	D1
	BMI.S	PR9_S
	LSL.W	#6,D1
	OR.W	D1,D5
PR9_S	BSR	EA
	ANDI.W	#$38,D2
	BEQ.S	PR9_D
	ANDI.W	#$FFC7,D5 clear mode
	ORI.W	#8,D5
	BRA.S	PR11_E
PR9_D	MOVE.W	#$7FFE,D7
	BRA.S	PR11_D
;
; ADDQ, SUBQ
;
PR10	LSL.W	#6,D1
	OR.W	D1,D5
	LEA	SIZE,A0
	MOVE.B	#3,(A0)
	SUBQ.L	#2,A5
	BSR	EA
	ADDQ.L	#2,A5
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	ANDI.W	#$38,D2
	CMPI.W	#$8,D2
	BNE	INST_END
	MOVE.W	D5,D2
	ANDI.W	#192,D2
	BEQ	PR_E16 ---->
	BRA	INST_END
;
; ADDA, SUBA, CMPA
;
PR11	TST.B	D1
	BEQ	PR_E16 ---->
PR11_F	LEA	SIZE,A0
	MOVE.B	D1,(A0)
	BTST	#1,D1
	BEQ.S	PR11_C
	BSET	#8,D5	set L
PR11_C	BSR	EA
PR11_E	SWAP	D7
PR11_D	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	BSR	EA
	ANDI.W	#7,D2
	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	BRA	INST_END
;
; BCHG, BCLR, BSET, BTST
;
PR12	LEA	SIZE,A0
	CLR.B	(A0)
	BSR	EA
	MOVE.W	D2,D3
	ANDI.W	#$38,D3
	BNE.S	PR12_74
	BSET	#8,D5
	ANDI.W	#7,D2
PR12_E	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	BRA.S	PR12_D
PR12_74	BSET	#11,D5
PR12_D	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	BRA	INST_END
;
; CHK, DIVS, DIVU, MULS, MULU, LEA
;
PR13	MOVEQ	#1,D1	set SIZE = WORD
	BRA.S	PR11_F
;
; CLR, JMP, JSR, NBCD, NEG, NEGX, NOT, PEA, Scc, TAS, TST
;
PR14	TST.B	D1
	BMI.S	PR14_B
PR14_C	LSL.W	#6,D1
	OR.W	D1,D5
PR14_B	BSR	EA
	BRA	INST_END
;
; EXT, SWAP, UNLK
;
PR15	TST.B	D1
	BMI.S	PR14_B	SWAP
	BEQ	PR_E16 ---->
	ADDQ.W	#1,D1
	BRA.S	PR14_C
;
; EXG
;
PR16	BSR	EA
	MOVE.W	D2,D3
	ANDI.W	#7,D2
	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	SWAP	D7
	ANDI.W	#8,D3
	BEQ.S	PR16_D
	MOVE.W	#$FFFD,D7 An only
PR16_D
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	BSR	EA
	ANDI.W	#8,D2
	CMP.W	D2,D3
	BEQ	INST_END
	ADDI.W	#64,D5
	BRA	INST_END
;
; MOVEA
;
PR17	TST.B	D1
	BEQ	PR_E16 ---->
	LEA	SIZE,A0	** Added 22 APR 01 **
	MOVE.B	D1,(A0)	**	"        **
	BTST	#0,D1
	BEQ	PR11_C
	BSET	#12,D5
	BRA	PR11_C
;
; MOVEP
;
PR18	SUBQ.W	#1,D1
	BMI	PR_E16 ---->
	LSL.W	#6,D1
	OR.W	D1,D5
	BSR	EA
	SWAP	D7
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	CMPI.B	#8,D2
	BLT.S	PR18_D
	BSR	EA
	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	BCLR	#7,D5
PR18_E	BCLR	#5,D5
	BRA	INST_END
PR18_D	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	ANDI.W	#$FFC0,D5
	MOVE.W	#$FFDF,D7
	BSR	EA
	BRA.S	PR18_E
;
; MOVEQ
;
PR19	LEA	SIZE,A0
	MOVE.B	#5,(A0)
	SUBQ.L	#2,A5
	BSR	EA
	ADDQ.L	#2,A5
	BRA	PR11_E
;
; LINK
;
PR20	LEA	SIZE,A0
	MOVE.B	#1,(A0)
	BSR	EA
	BCLR	#3,D5
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	BRA	INST_END
;
; STOP
;
PR21	LEA	SIZE,A0
	MOVE.B	#1,(A0)
	BSR	EA
	BRA	INST_END
;
; TRAP
;
PR22	LEA	SIZE,A0
	MOVE.B	#4,(A0)
	SUBQ.L	#2,A5
	BSR	EA
	ADDQ.L	#2,A5
	BRA	INST_END
;
; DS
;
PR23	MOVE.W	D1,D3	 Keep size
	SUBQ.L	#2,A5
	BSR	GNUM
	CMPI.B	#1,D1
	BNE	PR_E1 ---->
	LSL.L	D3,D2 x1 x2 x4 for .B .W .L
	MOVE.L	D2,D4	keep no of bytes in D4
	BMI	PR_E6 ---->
	LEA	O_BEND,A0
	MOVE.L	A0,D1
	LEA	O_BUF+4,A0
	SUB.L	A0,D1  buffer size -> D1
	BSR	PUT_BCT  ouput D2 bytes to BIN
	ADDA.L	D4,A5 set PC *NB may not be on a WORD boundary*
	BRA	INST_ED1
;
; DC
;
PR24	SUBQ.L	#2,A5
	MOVE.W	D1,D3	keep SIZE
PR24_AG	MOVEQ	#0,D7	mark 'number'
	MOVE.B	(A1),D0	next character
	CMPI.B	#'"',D0
	BEQ.S	PR24_STG
	CMPI.B	#"'",D0
	BNE.S	PR24_NUM
PR24_STG	MOVEQ	#-1,D7	mark 'string'
PR24_NUM
	BSR	GNUM
	TST.L	D7	'string'?
	BNE.S	PR24_NN	yes
;
; **** NEW BIT - 1 FEB 00 ****
;
	TST.B	D1
	BMI	PR_E1	---->
	BEQ	PR24_UL	unknown label
	CMPI.B	#2,D1
	BEQ	PR_E5	----> PC not allowed
	BGT	PR24_EQ	-> EQU list
;
; ****************************
;
	MOVE.L	D2,D5
	CMPI.W	#1,D3
	BLT.S	PR24_NB
	BEQ.S	PR24_NW
	SWAP	D5
PR24_NL	ADDQ.L	#2,A5
	BSR	PUT_W
	SWAP	D5
PR24_NW1	ADDQ.L	#2,A5
	BSR	PUT_W
PR24_SE	CMPI.B	#",",D0
	BEQ.S	PR24_AG
	CMPI.B	#10,D0
	BEQ	INST_ED1
	CMPI.B	#32,D0
	BEQ	INST_ED1
	CMPI.B	#9,D0
	BEQ	INST_ED1
	BRA	PR_E1 ---->
PR24_NW	BSR	CMP_W
	BMI	PR_E1 ---->
	BRA.S	PR24_NW1
PR24_NB	BSR	CMP_B
	BMI	PR_E1 ---->
PR24_NB1	ADDQ.L	#1,A5
	BSR	PUT_B
	BRA.S	PR24_SE
PR24_NN	LEA	BUF,A0
	MOVE.W	(A0)+,D4	length
	CMPI.W	#1,D3
	BLT.S	PR24_CB1
	BEQ.S	PR24_CW
	ADDQ.W	#3,D4
	LSR.W	#2,D4
	ADD.W	D4,D4 4(INT(D4+3)/4)
	BRA.S	PR24_L1
PR24_CW	ADDQ.W	#1,D4
	LSR.W	#1,D4
PR24_L1	ADD.W	D4,D4 2(INT(D4+1)/2)
	ADDA.W	D4,A5	advance PC
	LSR.W	#1,D4	count of WORDS
	BRA.S	PR24_L2
PR24_L3	MOVE.W	(A0)+,D5	 next word
	BSR	PUT_W
PR24_L2	DBF	D4,PR24_L3
	BRA.S	PR24_SE
PR24_L4	MOVE.B	(A0)+,D5
	BSR	PUT_B
PR24_CB	DBF	D4,PR24_L4
	BRA.S	PR24_SE
PR24_CB1	ADDA.W	D4,A5
	BRA.S	PR24_CB
;
PR24_EQ	MOVE.L	D2,D4	sign | pointer -> EQU list
	CLR.W	D2	prepare for dummy label number
	BCLR	#31,D4	clear sign from D4
	MOVEA.L	TLLAB,A4
	MOVEA.L	BLLAB,A0
PR24_EQ1	TST.W	(A0)
	BEQ	PR24_EQ2	found
	LEA	32(A0),A0 to next label
	ADDQ.W	#1,D2	count label number
	CMPA.L	A4,A0	more? . .
	BLT	PR24_EQ1	. . yes
	BRA	PR_E12	---->
;
PR24_EQ2	MOVE.W	#-1,(A0)	dummy label
	MOVE.L	D4,VAL(A0)	-> EQU list
	MOVE.W	#9,TYPE(A0)
;
PR24_UL	MOVEA.L	BINS,A4
	MOVEA.L	(A4),A0
	MOVE.L	A5,(A0)+	PC
	MOVE.W	D2,(A0)+	label number (unknown or dummy)
	MOVEQ	#0,D6
	TST.B	D3	size
	BNE	PR24_EQ3
	MOVEQ	#1,D6	w
PR24_EQ3	MOVE.B	D6,(A0)+
	MOVE.B	D3,D7
	ADDQ.B	#2,D7
	TST.L	D2	+ or -?
	BPL	PR24_EQ4
	BSET	#7,D7	mark -
PR24_EQ4	MOVE.B	D7,(A0)+
	MOVE.L	A0,(A4)	update BINS pointer
	MOVE.B	D3,D7
	EXT.W	D7
	ADD.W	D7,D7
	LEA	PR24_ZJ,A0
	ADDA.W	(A0,D7.W),A0
	JMP	(A0)
;
PR24_ZJ	DC.W	PR24_NB1-PR24_ZJ	B
	DC.W	PR24_NW1-PR24_ZJ	W
	DC.W	PR24_NL-PR24_ZJ	L
;
; DATA
;
PR25	SUBQ.L	#2,A5
	BSR	GNUM
	SUBQ.L	#1,D1	must be a known number
	BNE	PR_E1 ---->
	LEA	DATA,A0
	MOVE.L	D2,(A0)	set DATA
	BRA	INST_ED1
;
; IN
;
PR26	SUBQ.L	#2,A5
	BSR	STRG
	BMI	QUIT ---->
	MOVEA.L	A2,A0
	MOVEQ	#0,D3	OPEN_IN
	MOVEQ	#IO_OPEN,D0
	TRAP	#2
	TST.L	D0
	BNE	QUIT
PR26_1	LEA	CH_NO,A1
	MOVE.W	(A1),D0
	ADDQ.W	#1,D0
	MOVE.W	D0,(A1)
	LEA	CH_LST,A1
	LSL.W	#2,D0
	MOVE.L	A0,(A1,D0.W)
	LEA	CH_IN,A1
	MOVE.L	A0,(A1)
	BRA	INST_ED1
;
; PCK
;
PR27	SUBQ.L	#2,A5
	BSR	GNUM
	SUBQ.L	#1,D1
	BNE	PR_E1 ---->
	TST.L	D2
	BMI	PR_E1 ---->
	CMPI.L	#8,D2
	BGT	PR_E1 ---->
	LEA	PCK,A0
	MOVE.W	D2,(A0)
	BRA	INST_ED1
;
; EOR
;
PR28	LSL.W	#6,D1
	OR.W	D1,D5	size
	BSR	EA
	BRA	PR12_E
;
; LIB
;
PR29	SUBQ.L	#2,A5	reset A5
	BSR	STRG
	BMI	PR_E27 ---->
	MOVEQ	#0,D3
	MOVEA.L	A2,A0
	MOVEQ	#IO_OPEN,D0
	TRAP	#2
	TST.L	D0
	BNE	PR_E27 ---->
	MOVEA.L	A0,A6	keep CH_ID
	MOVEQ	#-1,D3
	MOVEQ	#64,D2
	LEA	LBUF,A1
	MOVEQ	#FS_HEADR,D0
	TRAP	#3
	TST.L	D0
	BNE	PR_E27 ---->
	MOVE.L	LBUF,D1	length of file
	MOVEQ	#-1,D2
	MOVEQ	#MT_ALCHP,D0
	TRAP	#1	get space for file
	TST.L	D0
	BNE.S	PR29_ER1 ---->
	MOVEA.L	A0,A3	keep address
	MOVEA.L	A6,A0	ch_id
	MOVEA.L	A3,A1
	MOVE.L	LBUF,D2
	MOVEQ	#-1,D3
	MOVEQ	#FS_LOAD,D0
	TRAP	#3	put file to A1
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2	and close it
	MOVE.L	D2,D5	length -> D5
	ADDA.L	D5,A5	adjust PC
	BSR	FLUSH1
	BCLR	#0,D5	odd?
	BEQ.S	PR29_E	no
	MOVEQ	#1,D7	set D7 (D7=0 @ PR29)
PR29_E	MOVEQ	#-1,D3
	MOVEA.L	CH_OUT,A0
	MOVEA.L	A3,A1
PR29_1	CMPI.L	#$7000,D5 wadge size
	BGT.S	PR29_2
	MOVE.W	D5,D2	remaining bytes
	BRA.S	PR29_3
PR29_2	MOVE.L	#$7000,D2
PR29_3	SUB.L	D2,D5
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3	send wodge
	TST.L	D5	end?
	BNE.S	PR29_1	no
	TST.L	D7	odd?
	BEQ.S	PR29_4	no
	MOVE.B	(A1),D5	last byte
	BSR	PUT_B
PR29_4	MOVEA.L	A3,A0
	MOVEQ	#MT_RECHP,D0
	TRAP	#1	release space
	MOVEA.L	PC_LST,A0
	MOVE.L	LINE_NO,D2
	LSL.L	#2,D2
	BSET	#7,4(A0,D2.L)	mark NEXT line -1
	BRA	INST_ED1
;
PR29_ER1	MOVEA.L	A6,A0
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	BRA	PR_E28 ---->
;
; MACRO
;
PR30	MOVE.L	BLLAB,A2
	ADDA.L	D3,A2
	ORI.W	#3,TYPE(A2)	mark 'error' for real LABEL
	SUBQ.L	#2,A5	adjust PC
	LEA	MAC_LST,A0
	BSR	G_MAC
	BEQ	PR_E30 ---->
	LEA	TMACLST,A3
	BSR	NEW_MAC	put NAME in MAC_LST
	LEA	MAC_NO,A0
	MOVE.W	(A0),D0	No of MACRO
	ADDQ.W	#1,(A0)	advance No
	MOVEQ	#IO_OPEN,D4
	MOVEQ	#3,D3
	BSR	PR30_FLE
	MOVEA.L	A0,A6	keep CH_ID
	MOVE.L	LINE_NO,D2
PR30_AG	MOVEA.L	PC_LST,A0
	LSL.L	#2,D2
	MOVE.L	A5,(A0,D2.L)
	MOVEA.L	CH_IN,A0
	LEA	LBUF,A1
	MOVE.W	#256,D2	buffer size
	MOVEQ	#-1,D3
	MOVEQ	#IO_FLINE,D0
	TRAP	#3
	TST.L	D0
	BEQ.S	PR30_3
	CMPI.B	#-10,D0	EOF?
	BNE	QUIT ----> no
	TST.W	D1	any bytes fetched?
	BEQ	PR_E29 ----> (No ENDM)
	MOVE.B	#10,(A1)	put LF
PR30_3	LEA	LBUF,A1
	MOVEA.L	CH_TMP,A0
	MOVE.W	D1,D2	No of bytes
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QUIT ---->
	MOVEQ	#0,D5	mark no '\' (as yet)
	LEA	LBUF,A1
	MOVE.B	(A1)+,D0
	CMPI.B	#32,D0
	BEQ.S	PR30_SP1
	CMPI.B	#9,D0
	BEQ	PR30_SP1
	BSR	CH_LET
	BEQ.S	PR30_4
	BRA	PR30_E1	next line
PR30_4	MOVE.B	(A1)+,D0
	CMPI.B	#32,D0	SPACE?
	BEQ.S	PR30_SP1	yes - go on
	CMPI.B	#9,D0
	BEQ	PR30_SP1
	CMPI.B	#10,D0	ENTER?
	BEQ	PR30_E2	yes - end of line
	CMPI.B	#'\',D0
	BNE.S	PR30_4
	MOVEQ	#1,D5	mark '\' been
	BRA.S	PR30_4
PR30_SP1	CMPI.B	#32,(A1)+
	BEQ.S	PR30_SP1
	CMPI.B	#9,-1(A1)
	BEQ	PR30_SP1
	SUBQ.L	#1,A1
	MOVE.L	#'MDNE',D6
PR30_5	MOVE.B	(A1)+,D0
	CMP.B	D6,D0
	BEQ.S	PR30_6
	ADDI.B	#32,D6
	CMP.B	D6,D0
	BNE.S	PR30_E
PR30_6	LSR.L	#8,D6	next character
	BNE.S	PR30_5
;
; 'ENDM' found
;
	MOVEA.L	A6,A0	retrieve CH_ID
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	BSR.S	PR30_LN
	BRA	INST_ED1
;
PR30_E	CMPI.B	#10,D0	***************
	BEQ.S	PR30_E2	*    get	    *
	CMPI.B	#32,D0	*   past	    *
	BEQ.S	PR30_E3	* instruction *
	CMPI.B	#9,D0	***************
	BEQ	PR30_E3
	MOVE.B	(A1)+,D0
	BRA.S	PR30_E
;
PR30_E3	MOVE.B	(A1)+,D0	***************
	CMPI.B	#32,D0	*  get past   *
	BEQ.S	PR30_E3	*   SPACES    *
;			***************
	CMPI.B	#9,D0
	BEQ	PR30_E3
PR30_E4	CMPI.B	#10,D0
	BEQ.S	PR30_E2	***************
	CMPI.B	#32,D0	*  get past   *
	BEQ.S	PR30_E6	*  addresses  *
	CMPI.B	#9,D0	***************
	BEQ	PR30_E6
	CMPI.B	#'\',D0
	BNE.S	PR30_E5
	MOVEQ	#1,D5	mark '\' been
PR30_E5	MOVE.B	(A1)+,D0
	BRA.S	PR30_E4
;
PR30_E6	MOVE.B	#10,-1(A1)	put '10' @ end
PR30_E2	MOVE.L	A1,D2
	LEA	LBUF,A1
	SUBA.L	D5,A1
	SUB.L	A1,D2	length of line
	MOVEA.L	A6,A0	retrieve CH_ID
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QUIT ---->
PR30_E1	BSR.S	PR30_LN
	BRA	PR30_AG
;
PR30_LN	LEA	LINE_NO,A0
	MOVE.L	(A0),D2
	ADDQ.L	#1,D2
	CMP.L	MAX_LINES,D2
	BGE	QUITB ---->
	MOVE.L	D2,(A0)
	RTS
;
; To open or delete a file
;
; on entry:-
;    D3 = type of open
;    D0 = No  of MACRO
;    D4 = #IO_xxx
;
PR30_FLE	LEA	MAC_BUF,A0
	LEA	TMP_NME,A2
	MOVE.W	(A2)+,D1	length
	MOVE.W	D1,(A0)+
	BRA.S	PR30_F1
PR30_F2	MOVE.B	(A2)+,(A0)+
PR30_F1	DBF	D1,PR30_F2
	EXT.L	D0
	BSR	LTOD
	MOVEQ	#-1,D1
	MOVE.L	D4,D0
	LEA	MAC_BUF,A0
	TRAP	#2
	TST.L	D0
	BNE	QUIT ---->
	RTS
;
; any MACRO name
;
; at entry D1 = MACRO No
;
PR31	LEA	MAC_CT,A0
	ADDQ.W	#1,(A0)
	SUBQ.L	#2,A5	     adjust PC
	LINK	A6,#-STK_SIZE  get space for parameters
	MOVE.L	A6,-(A7)	keep pointer
	MOVEQ	#0,D3	no of parameters
	MOVE.W	D1,D5	keep macro number
	LEA	-2(A6),A6 keep space for count
	CMPI.B	#10,(A1)	any parameters?
	BEQ.S	PR31_F	no
PR31_P	BSR	STRG	get parameter
	BMI.S	PR31_ER1 ---->
	MOVEQ	#7,D4
	LEA	-32(A6),A6   get space for parameter
PR31_P1	MOVE.L	(A2)+,(A6)+  store parameter
	DBF	D4,PR31_P1
	LEA	-32(A6),A6   set pointer to next par
	ADDQ.W	#1,D3	advance count
	CMPI.W	#MAX_PAR,D3
	BGT.S	PR31_ER2 ---->
	CMPI.B	#',',D0	more?
	BEQ.S	PR31_P	yes
	CMPI.B	#10,D0
	BNE.S	PR31_ER3 ---->
PR31_F	MOVEA.L	(A7),A6	restore pointer
	MOVE.W	D3,-2(A6) enter count
	MOVEQ	#0,D3	open_in
	MOVEQ	#IO_OPEN,D4
	MOVE.W	D5,D0	set macro number to D0.W
	BSR.S	PR30_FLE
	ADDA.L	#$80000000,A0   mark MACRO
	BRA	PR26_1
;
PR31_ER1	MOVE.W	D1,-(A7)
	MOVEQ	#31,D1
PR31_ERX	BSR	DO_ERR
	MOVE.W	(A7)+,D1
	BRA.S	PR31_F
PR31_ER2	MOVE.W	D1,-(A7)
	MOVEQ	#32,D1
	BRA.S	PR31_ERX
PR31_ER3	MOVE.W	D1,-(A7)
	MOVEQ	#9,D1
	BRA.S	PR31_ERX
