; SYM_ASM on D61
; 11 May 1994
;
; To produce an EQU table from a _SYM file
;
WHITE     EQU       7
BLACK     EQU       0
GREEN     EQU       4
RED       EQU       2
VAL       EQU       26
TYPE      EQU       30
BUF_SIZE  EQU       60
;
          BRA.S     START
          DS.L      1
          DC.W      $4AFB
          DC.W      7
          DC.B      "TRA_SYM"
;
START     LEA       CON,A1
          MOVE.W    UT_CON,A2
          JSR       (A2)
          LEA       ID_CON,A1
          MOVE.L    A0,(A1)
GWAG1     MOVEA.L   ID_CON,A0
          MOVEQ     #-1,D3
          MOVEQ     #SD_CLEAR,D0
          TRAP      #3        clears window
          MOVE.B    CON,D1    color -> D1
          MOVE.B    CON+1,D2
          EXT.W     D2        width -> D2
          MOVEQ     #SD_BORDR,D0
          TRAP      #3
          LEA       HEAD0,A1
          BSR       UMT1
          LEA       HEAD0A,A1
          BSR       UMT1
          LEA       HEAD0B,A1
          BSR       UMT1
          BSR       CURON     put on cursor
;
;         Menu
;
GWAG2     MOVEQ     #IO_FBYTE,D0
          TRAP      #3
          CMPI.B    #244,D1
          BEQ.S     GWAG1     F4 - redraw
          ADDQ.B    #1,D1
          CMPI.B    #'2',D1
          BEQ.S     REPRINT
          CMPI.B    #'3',D1
          BNE.S     GWAG2     get 1,2, or F4
REPRINT   MOVE.B    D1,D2
          SUB.B     #48,D2
          MOVE.B    D2,D7     keep 1,2 in D7
          MOVEQ     #WHITE,D1
          BSR       INK
          MOVEQ     #0,D1
          BSR       AT
          CMPI.B    #2,D2
          BEQ.S     REP1      process
          LEA       HEAD0B,A1
          BRA.S     REP2      quit
REP1      LEA       HEAD0A,A1
REP2      BSR       UMT1
          MOVEQ     #GREEN,D1
          BSR       INK
          BSR       CUROF
          CMPI.B    #2,D7
          BNE       QUIT1     EXIT for good!
REP3      MOVEQ     #0,D1    re-entry after BEEP
          MOVEQ     #5,D2
          BSR       AT
          LEA       HEAD1,A1
          BSR       UMT1
          MOVEQ     #SD_NL,D0
          TRAP      #3        new line
          LEA       BUF,A1    to get X-POS etc
          MOVEQ     #SD_CHENQ,D0
          TRAP      #3
          MOVE.W    BUF+4,D1  X-POS
          SWAP      D1
          MOVE.W    prompt,D1
          MOVE.W    #40,D2    buffer length
          LEA       prompt+2,A1
          ADDA.W    D1,A1
          MOVEQ     #IO_EDLIN,D0
          TRAP      #3
          LEA       prompt,A0
          MOVE.L    A1,D0
          LEA       prompt+2,A1
          SUB.L     A1,D0
          SUBQ.W    #1,D0
          MOVE.W    D0,(A0)   set length of name
          BEQ       GWAG1     No file - try again
          MOVEQ     #-1,D1
          MOVEQ     #0,D3     OPEN_IN
          MOVEQ     #IO_OPEN,D0
          TRAP      #2
          TST.B     D0
          BNE       BEEP      can't open - try again
          LEA       CH_ID,A1
          MOVE.L    A0,(A1)   keep ID
          MOVEQ     #64,D2    header length
          MOVEQ     #-1,D3
          LEA       O_BUF,A1  space for header
          MOVEQ     #FS_HEADR,D0
          TRAP      #3
          TST.L     D0
          BNE       BEEP      can't open!!
          TST.B     -59(A1)   check type
          BNE       BEEP      not type 0
;
; **** NEW STUFF ****
;
          MOVE.L    -64(A1),D1          length of file
          MOVE.L    D1,D4               keep in D4
          MOVEQ     #-1,D2    this job
          MOVEQ     #MT_ALCHP,D0
          TRAP      #1
          TST.L     D0
          BNE       ER_OM    ---->
          LEA       AL_SP,A1
          MOVE.L    A0,(A1)
          MOVEA.L   A0,A5
          MOVE.L    D4,D2     length of file
          MOVEQ     #-1,D3
          MOVEA.L   A0,A1
          MOVEA.L   CH_ID,A0
          MOVEQ     #FS_LOAD,D0
          TRAP      #3
          TST.L     D0
          BNE       ER_NF ---->   can't load
;
; A5 = LAB LIST
; A0 is the file ID
;
          MOVEQ     #IO_CLOSE,D0
          TRAP      #2        close file
;
          LEA       PROMPT,A1
          MOVE.W    (A1),D2
          ADDQ.W    #4,(A1)
          LEA       2(A1,D2.W),A1
          MOVEQ     #3,D2
          LEA       TRAIL1,A2
PRO1      MOVE.B    (A2)+,(A1)+
          DBF       D2,PRO1
          LEA       PROMPT,A0
          MOVEQ     #-1,D1
          MOVEQ     #3,D3
          MOVEQ     #IO_OPEN,D0
          TRAP      #2
          TST.L     D0
          BNE       ER_NOPE ---->
          LEA       CH_ID,A1
          MOVE.L    A0,(A1)
; INNER LOOP
; ************
;
          MOVEA.L   AL_SP,A5
          SUBA.W    #32,A5
LOOP      ADDA.W    #32,A5    next
          MOVE.W    (A5),D2
          BMI.S     LOOP      not a label
          BEQ.S     END       end of labels
PA_EX     MOVEQ     #63,D1
          MOVE.L    #$20202020,D0
          LEA       LBUF,A0       fill LBUF with SPACES
PA_CL     MOVE.L    D0,(A0)+
          DBF       D1,PA_CL
;
          LEA       LBUF,A0
          LEA       2(A5),A4
          BRA.S     LOOP2
LOOP3     MOVE.B    (A4)+,(A0)+
LOOP2     DBF       D2,LOOP3
          LEA       LBUF+28,A0
          BTST      #0,TYPE+1(A5)
          BEQ.S     LOOP4
          LEA       LK1,A1
          BRA.S     LOOP5
LOOP4     LEA       LK2,A1
LOOP5     MOVE.W    (A1)+,D2
          BRA.S     LOOP6
LOOP7     MOVE.B    (A1)+,(A0)+
LOOP6     DBF       D2,LOOP7
          MOVE.W    CN_ITOHL,A2
          SUBA.L    A1,A1
          LEA       VAL(A5),A6
          SUBA.L    A6,A0
          JSR       (A2)
          ADDA.L    A6,A0
          MOVE.B    #10,(A0)+
          MOVE.L    A0,D2
          LEA       LBUF,A1
          SUB.L     A1,D2
          MOVEA.L   CH_ID,A0  channel for output
          MOVEQ     #IO_SSTRG,D0
          TRAP      #3
          BRA.S     LOOP
;
END       MOVEA.L   CH_ID,A0
          MOVEQ     #IO_CLOSE,D0
          TRAP      #2
          MOVEA.L   AL_SP,A0
          MOVEQ     #MT_RECHP,D0
          TRAP      #1
          LEA       PROMPT,A0
          SUBQ.W    #4,(A0)   strip off _SYM from prompt
          BPL.S     END1
          ADDQ.W    #4,(A0)   add back if <0
END1      BRA       GWAG1
;
UMT       MOVEA.L   ID_CON,A0
UMT1      MOVE.W    UT_MTEXT,A2
          JSR       (A2)
          RTS
;
PA_HX     SUBA.L    A1,A1
          SUBA.L    A6,A0
          JSR       (A2)
          ADDA.L    A6,A0
          ADDA.L    A1,A6
          MOVE.B    #32,(A0)+
          RTS
;
CON       DC.B      230,2     border
          DC.B      RED,GREEN paper/ink
          DC.W      340,84,80,30
;
HEAD0     DC.W      33
          DC.B      "                  GDG ASSEMBLER",10,10
HEAD0A    DC.W      20
          DC.B      "1  Decode _SYM file",10
HEAD0B    DC.W      8
          DC.B      "2  QUIT",10
HEAD1     DC.W      21
          DC.B      "Give source filename "
PROMPT    DC.W      5
FILE      DC.B      "RAM1_"
          DS.B      35
;
CURON1    MOVEQ     #-1,D3
CURON     MOVEQ     #SD_CURE,D0
          BRA.S     TP3
;
CUROF1    MOVEQ     #-1,D3
CUROF     MOVEQ     #SD_CURS,D0
          BRA.S     TP3
;
AT        MOVEQ     #SD_POS,D0
TP3       TRAP      #3
          RTS
;
INK       MOVEQ     #SD_SETIN,D0
          BRA.S     TP3
;
TRAIL1
          DC.B      '_LST'
;
BEEP      BSR.S     BLP
          MOVEA.L   ID_CON,A0
          BRA       REP3
;
BLP       LEA       NOISE,A3
          MOVEQ     #MT_IPCOM,D0
          TRAP      #1
          RTS
;
NOISE     DC.B      10,8
          DC.L      $AAAA
          DC.B      1,20,90,0,$10,$27
          DC.B      $F4,$A2,1,0
;
QUIT1     MOVEQ     #MT_FRJOB,D0
          MOVEQ     #-1,D1
          TRAP      #1
;
ER_OM     LEA       OM,A1
          BRA.S     OUT
;
ER_NF     LEA       NF,A1
          BRA.S     OUT
;
ER_NOPE   LEA       NOPE,A1
OUT       MOVEQ     #3,D1
          MOVEQ     #8,D2
          BSR.S     AT
          BSR       UMT
          BRA       QUIT1
;
OM        DC.W      13
          DC.B      "Out of memory"
NF        DC.W      15
          DC.B      "Can't load file"
NOPE      DC.W      15
          DC.B      "Can't open file"
BUF       DS.L      64
O_BUF     DS.L      64
CH_ID     DS.L      1
AL_SP     DS.L      1
LBUF      DS.L      64
ID_CON    DS.L      1
LK1       DC.W      9
          DC.B      "  EQU   $"
LK2       DC.W      11
          DC.B      "  EQU   *+$"
